<script lang="ts">
  import HeroBanner from '$lib/components/layout/HeroBanner.svelte';
  import Finalists from '$lib/components/pages/home/Finalists.svelte';
  import Info from '$lib/components/pages/home/Info.svelte';
  import InfoCards from '$lib/components/pages/home/InfoCards.svelte';
  import PageHeader from '$lib/components/layout/PageHeader.svelte';
  import Spinner from '$lib/components/ui-elements/Spinner.svelte';
  import { EventResultTeams$result, EventResultTeamsStore } from '$houdini';

  const year = "2024";
  const final_event = "Invitational";
  const final_event_group = `NCAE CyberGames ${year} Invitational`;
  const regional_event_group = `NCAE CyberGames ${year} Regionals`;
  let store = new EventResultTeamsStore();

  async function fetchEventResults() {
    const ret: {
      winner: EventResultTeams$result['final_event_results'][0]['team'] | null,
      teams: NonNullable<EventResultTeams$result['regional_event_results']>
    } = {
      winner: null,
      teams: [],
    }
    const result = await store.fetch({
      variables: {
        final_event_name: final_event,
        final_event_group_name: final_event_group,
        regional_event_group_name: regional_event_group,
      }
    })
    if (!result.data?.final_event_results || !result.data?.regional_event_results) {
      return ret
    }
    ret.winner = result.data?.final_event_results[0].team
    ret.teams = result.data?.regional_event_results
    return ret
  }
</script>

<PageHeader title="Home" />

<HeroBanner binary>
  <h1 class="text-3xl lg:text-4xl xl:text-5xl font-bold">All Play Mode</h1>
  <h1 class="text-6xl lg:text-7xl xl:text-8xl italic font-black">Enabled</h1>
  <h1 class="text-2xl lg:text-3xl xl:text-4xl">
    Welcome to the <span class="font-semibold">NCAE CYBER GAMES</span>
  </h1>
</HeroBanner>

<div class="mt-20 2xl:container mx-auto">
  <Info />

  {#await fetchEventResults()}
    <Spinner size=20 class="my-5"/>
  {:then data}
    <Finalists teams={data.teams} winner={data.winner} {year}>
      <section class="mb-5 w-full bg-cyber-blue-900 text-center pt-6 pb-6 pl-8 pr-8">
        <h1 class="text-secondary text-3xl font-bold uppercase">Thank you for joining us this {year} season!</h1>
        <p class="text-xl leading-9 text-white font-normal pt-3">
          Congratulations to all our {year} regional and {final_event.toLowerCase()} champions!
          <br />
          Thank you to all the teams that participated in the regional events and the {final_event.toLowerCase()}!
          <br />
          We hope to see everyone for our {Number(year)+1} competition season!
        </p>
      </section>
    </Finalists>
  {/await}

  <InfoCards />
</div>
